%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% 
%%%  Semi-parametric detector of long memory change
%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Bardet 2017
%
% In: an observed process (vector) X
% 
% Out: 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


pkg load statistics 
pkg load tsa
pkg load signal


n=length(X)
Kmax=2*(fix(log(n))-1)
pas=fix(n/160)
tt=max(fix(0.7*sqrt(n)),fix(n/(5*Kmax))); 
Z=0;  T=0; tau=0; dest=0; C=0; cout=0;
p=0; q=0;
m=fix(n^0.65);

for t1=1:pas:(n-pas)
    p=p+1;
    q=p;
    for t2=pas+t1:pas:n
        I=0;
        R=0;
        lambda=0;
        mmax=min((t2-t1-1),m);
        lambda= 2*pi*(1:mmax)'/n;
        if (t2-t1<tt) 
          cout(p,q)=1000;
          else
        R=acovf(traj(t1:t2))';
        I=R(1)+2*sum(R(2:(t2+1-t1)).*cos((1:(t2-t1))'*lambda'));
        J=I(1:mmax)'/(2*pi);
        LocFun=inline('log(mean(lambda.^(2*d).*J))-2*d*mean(log(lambda))','d');
        dd= fminbnd(LocFun,-0.5,0.5);
        DD(p,q)=dd;
        cout(p,q)=(t2-t1+1)*LocFun(dd)/n;
        end
        q=q+1;
    end
end
[y,y]=size(cout);
A=0;
C = zeros(Kmax,y);
Z=zeros(Kmax-1,y);
C(1,1:y)=cout(1,1:y);
for t=2:y
    [A,Z(1,t)]=min(C(1,1:(t-1))'+cout((2:t),t));
end
for k=1:(Kmax-1)  % dynamic programing
    for t=2:y
        [C(k+1,t),Z(k,t)]=min(C(k,1:(t-1))'+cout((2:t),t));
    end
end
Contraste=0; X=0; slope=0;
Contraste(1:Kmax)=C(1:Kmax,y);

T=zeros(Kmax-1,Kmax);
dest=zeros(Kmax-1,Kmax-1);
T(1:(Kmax-1),1)=1;
for i=1:(Kmax-1)
    T(i,i+1)=y;
end
for k=2:(Kmax-1)
    for j=k:-1:2
        T(k,j)=Z((j-1),T(k,j+1));
    end
end
for k=1:(Kmax-1)
    for j=1:k
        dest(k,j)=DD(T(k,j),T(k,j+1));
    end
end
tauest=(1+(T-1)*pas).*(T>0)/n;
tauest(:,1)=0;
test=(1+(T-1)*pas).*(T>0);
test(:,1)=1;
for k=1:(Kmax-1)
  test(k,k+1)=n;
end 


for Kdeb=1:(fix(Kmax/2)-2)
    X=[ones(1,(Kmax-Kdeb));((Kdeb+1):Kmax)];
    b=regress(2*Contraste((Kdeb+1):Kmax)',X');
    slope(Kdeb)=b(2);
end
for c=((fix(Kmax/2))-1):Kmax
    slope(c)=b(2);
end
[A,Ktheo]=min(Contraste+2/sqrt(n)*(1:Kmax)); 
[A,KBIC]=min(Contraste+log(n)*(1:Kmax)); 
[A,KH]=min(2*Contraste(1:Kmax)'-2*b(2).*(1:Kmax)');

for p=1:KH
  dest2(p)=LocWhittleADG(traj(test(KH,p):test(KH,p+1)),(test(KH,p+1)-test(KH,p))^0.64);
end
KH                     % estimator of $K$
TES(1:Kmax)=test(KH,:) % estimators of $t_k$
DES(1:KH)=dest2(1:KH)  % estimators of $d_k$